## gpsshogi 0.7.0

=== bin/CMakeLists.txt ===
project (gpsshogi CXX)
set (CMAKE_VERBOSE_MAKEFILE on)

# Tweak build mode
if(NOT CMAKE_BUILD_TYPE)
        set(CMAKE_BUILD_TYPE "Debug" CACHE STRING "" FORCE)
endif()

if(NOT CMAKE_BUILD_TYPE MATCHES "^[Dd][Ee][Bb][Uu][Gg]")
        add_definitions(-DQT_NO_DEBUG_OUTPUT)
        set(CMAKE_BUILD_RELEASE TRUE)
else()
        set(CMAKE_BUILD_RELEASE FALSE)
endif()

# Installation directory
if(APPLE AND CMAKE_INSTALL_PREFIX MATCHES "/usr/local")
        set(CMAKE_INSTALL_PREFIX "/Applications")
endif()

message(STATUS "Building ${PROJECT_NAME} in ${CMAKE_BUILD_TYPE} mode")
cmake_minimum_required(VERSION 2.8.8)
set (CMAKE_VERBOSE_MAKEFILE on)

ENABLE_TESTING()

# Basic build options
if(CMAKE_COMPILER_IS_GNUCXX OR MINGW OR APPLE)
  #if(CMAKE_BUILD_RELEASE)
  #        add_definitions(-Werror)
  #endif()
  set (CMAKE_CXX_FLAGS "-Wall -D_REENTRANT")
  set (CMAKE_CXX_FLAGS_DEBUG "-O0 -g -DDEBUG")
  set (CMAKE_CXX_FLAGS_RELEASE "-O3 -DNDEBUG -funroll-loops -funswitch-loops -fpeel-loops --param large-function-growth=48000 --param inline-unit-growth=8000 --param max-inline-insns-single=8000 -fomit-frame-pointer")

  add_definitions(-DOSL_SMP=1 -DOSL_DFPN_SMP_SEARCH -DMORE_CHECKMATE_IF_CAPTURE_MAJOR -DUSE_TCMALLOC=0 -DUSE_BOOST_POOL_ALLOCATOR=1)
  add_definitions(-DBOOST_FILESYSTEM_VERSION=3) 
endif()

# Compiler specific build options
if(MINGW)
  set (CMAKE_CXX_FLAGS "-Wall -D_REENTRANT -D_MT -mthreads -mwin32 -msse2 -static-libgcc -static-libstdc++ -DWIN32_LEAN_AND_MEAN")
  add_definitions(-march=pentium4)
  add_definitions(-D_WIN32_WINNT=0x0500)

  set (BOOST_ROOT "$ENV{HOME}/local/src/boost_1_46_1/")
  find_library(Winsock2_LIBRARY ws2_32)
elseif (APPLE)
  set (CMAKE_CXX_COMPILER "/usr/local/bin/g++-4.7")
  set (CMAKE_CXX_FLAGS "-Wall -D_REENTRANT -m64 -fno-common")
  add_definitions(-march=core2)

  set (BOOST_ROOT "/usr/local/Cellar/boost/1.54.0")
endif()

add_definitions(-DOSL_HOME="/Applications/${PROJECT_NAME}.app")

include_directories ("${PROJECT_SOURCE_DIR}")
include_directories ("${PROJECT_SOURCE_DIR}/../include")
include_directories ("${PROJECT_SOURCE_DIR}/../../osl/include")

#
# Third-party libraries
#

if (MINGW)
  ## bzip2
  find_library(Bz2_LIBRARY bz2 PATH "/usr/i686-w64-mingw32/lib"
               NO_DEFAULT_PATH)

  ## psapi
  find_library(Psapi_LIBRARY psapi PATH "/usr/i686-w64-mingw32/lib"
               NO_DEFAULT_PATH)
else()
  find_library(Bz2_LIBRARY bz2)
  find_library(Iconv_LIBRARY iconv)
endif()

## Boost thing
#set(Boost_DEBUG ON)
set (Boost_USE_STATIC_LIBS ON)
set (Boost_USE_MULTITHREADED ON)
if (MINGW)
  find_package (Boost 1.46.1 COMPONENTS program_options date_time filesystem serialization iostreams thread_win32 system)
else()
  find_package (Boost 1.54.0 COMPONENTS program_options date_time filesystem serialization iostreams thread system)
endif()
if (Boost_FOUND)
  include_directories (${Boost_INCLUDE_DIRS})
  message (STATUS ${Boost_INCLUDE_DIRS})
else()
  message (FATAL_ERROR "Boost installation not found")
endif()

## Import libosl.a
add_library (osl STATIC IMPORTED)
set_property (TARGET osl PROPERTY IMPORTED_LOCATION_DEBUG   ${PROJECT_SOURCE_DIR}/../../osl/build-Debug/libosl.a)
set_property (TARGET osl PROPERTY IMPORTED_LOCATION_RELEASE ${PROJECT_SOURCE_DIR}/../../osl/build-Release/libosl.a)

## gpsshogi
set(GPSSHOGI_HEADERS  options.h)
set(GPSSHOGI_SRCS     gpsshogi.cc)
set(GPSSHIGI_ALL_SRCS ${GPSSHOGI_HEADERS} ${GPSSHOGI_SRCS})
add_executable(gpsshogi MACOSX_BUNDLE ${GPSSHIGI_ALL_SRCS})
target_link_libraries (gpsshogi osl)
target_link_libraries (gpsshogi ${Boost_PROGRAM_OPTIONS_LIBRARY})
target_link_libraries (gpsshogi ${Boost_FILESYSTEM_LIBRARY})
target_link_libraries (gpsshogi ${Boost_SERIALIZATION_LIBRARY})
target_link_libraries (gpsshogi ${Boost_IOSTREAMS_LIBRARY})
target_link_libraries (gpsshogi ${Boost_SYSTEM_LIBRARY})
target_link_libraries (gpsshogi ${Bz2_LIBRARY})
if (MINGW)
  target_link_libraries (gpsshogi ${Boost_THREAD_WIN32_LIBRARY})
  target_link_libraries (gpsshogi ${Psapi_LIBRARY})
  target_link_libraries (gpsshogi ${Winsock2_LIBRARY})
else()
  target_link_libraries (gpsshogi ${Boost_THREAD_LIBRARY})
  target_link_libraries (gpsshogi ${Iconv_LIBRARY})
endif()

## gpsusi
set(GPSUSI_HEADERS  options.h)
set(GPSUSI_SRCS     gpsusi.cc)
set(GPSUSI_ALL_SRCS ${GPSUSI_HEADERS} ${GPSUSI_SRCS})
add_executable(gpsusi MACOSX_BUNDLE ${GPSUSI_ALL_SRCS})
target_link_libraries (gpsusi osl)
target_link_libraries (gpsusi ${Boost_PROGRAM_OPTIONS_LIBRARY})
target_link_libraries (gpsusi ${Boost_DATE_TIME_LIBRARY})
target_link_libraries (gpsusi ${Boost_FILESYSTEM_LIBRARY})
target_link_libraries (gpsusi ${Boost_SERIALIZATION_LIBRARY})
target_link_libraries (gpsusi ${Boost_IOSTREAMS_LIBRARY})
target_link_libraries (gpsusi ${Boost_SYSTEM_LIBRARY})
target_link_libraries (gpsusi ${Bz2_LIBRARY})
if (MINGW)
  target_link_libraries (gpsusi ${Boost_THREAD_WIN32_LIBRARY})
  target_link_libraries (gpsusi ${Psapi_LIBRARY})
  target_link_libraries (gpsusi ${Winsock2_LIBRARY})
else()
  target_link_libraries (gpsusi ${Boost_THREAD_LIBRARY})
  target_link_libraries (gpsusi ${Iconv_LIBRARY})
endif()

## installer
set(PROJECT_VERSION_MAJOR "20130810")
set(PROJECT_VERSION_MINOR "1")
set(PROJECT_VERSION_PATCH "0")
set(PROJECT_VERSION_COUNT 3)
set(PROJECT_VERSION "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}")
set(PROJECT_VENDOR "TeamGPS")
set(PROJECT_COPYRIGHT_YEAR "2013")

set(ICONS_DIR "${PROJECT_SOURCE_DIR}/icons")
if(APPLE)
  set(BIN_INSTALL_DIR ".")
  set(DOC_INSTALL_DIR "${PROJECT_NAME}.app")
  set(DATA_INSTALL_DIR "${PROJECT_NAME}.app/data")
else()
  string(TOLOWER ${PROJECT_NAME} PROJECT_NAME_LOWERCASE)
  set(BIN_INSTALL_DIR "smp")
  set(DOC_INSTALL_DIR "smp")
  set(DATA_INSTALL_DIR "data")
  set(DOC_INSTALL_DIR "share/doc/${PROJECT_NAME_LOWERCASE}/")
endif()

if(APPLE)
  set(MACOSX_BUNDLE_INFO_STRING "${PROJECT_NAME} ${PROJECT_VERSION}")
  set(MACOSX_BUNDLE_BUNDLE_VERSION "${PROJECT_NAME} ${PROJECT_VERSION}")
  set(MACOSX_BUNDLE_LONG_VERSION_STRING "${PROJECT_NAME} ${PROJECT_VERSION}")
  set(MACOSX_BUNDLE_SHORT_VERSION_STRING "${PROJECT_VERSION}")
  set(MACOSX_BUNDLE_COPYRIGHT "${PROJECT_COPYRIGHT_YEAR} ${PROJECT_VENDOR}")
  #set(MACOSX_BUNDLE_ICON_FILE "audio-input-microphone.icns")
  set(MACOSX_BUNDLE_GUI_IDENTIFIER "gps.tanaka.ecc.u-tokyo.ac.jp")
  set(MACOSX_BUNDLE_BUNDLE_NAME "${PROJECT_NAME}")
  set(MACOSX_BUNDLE_RESOURCES "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.app/Contents/Resources")
  #set(MACOSX_BUNDLE_ICON "${ICONS_DIR}/${MACOSX_BUNDLE_ICON_FILE}")
  execute_process(COMMAND ${CMAKE_COMMAND} -E make_directory ${MACOSX_BUNDLE_RESOURCES})
  execute_process(COMMAND ${CMAKE_COMMAND} -E copy_if_different ${MACOSX_BUNDLE_ICON} ${MACOSX_BUNDLE_RESOURCES})
endif()

if(APPLE)
        set(CMAKE_INSTALL_PREFIX "/Applications")
endif()

message(STATUS "${PROJECT_NAME} will be installed to ${CMAKE_INSTALL_PREFIX}")


# CPack

set(CPACK_GENERATOR "TBZ2")
set (CPACK_PACKAGE_VENDOR "${PROJECT_VENDOR}")
set (CPACK_PACKAGE_DESCRIPTION_SUMMARY "GPSShogi by TeamGPS")
set (CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_CURRENT_SOURCE_DIR}/../sample/binary-dist/gpsshogi_setup/README.ja.txt")
set (CPACK_PACKAGE_VERSION_MAJOR "${PROJECT_VERSION_MAJOR}")
set (CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/../sample/binary-dist/GPL-2")
#set (CPACK_PACKAGE_EXECUTABLES gpsshogi;gpsshogi) # do not create start menu
set (CPACK_PACKAGE_INSTALL_DIRECTORY "gpsshogi")

# Specific to NSIS (Windows)
if (MINGW)
  set (CPACK_GENERATOR "NSIS")
  #set(CPACK_PACKAGE_INSTALL_REGISTRY_KEY HKCU "/Environment/OSL_HOME" ${CPACK_NSIS_INSTALL_ROOT})
  set (CPACK_NSIS_PACKAGE_NAME "GPSShogi")
  set (CPACK_NSIS_DISPLAY_NAME "GPSShogi")
  set (CPACK_NSIS_URL_INFO_ABOUT "http://gps.tanaka.ecc.u-tokyo.ac.jp/gpsshogi/")
  set (CPACK_NSIS_HELP_LINK "http://gps.tanaka.ecc.u-tokyo.ac.jp/gpsshogi/")
  ## registry key for OSL_HOME environment variable
  set (CPACK_NSIS_EXTRA_INSTALL_COMMANDS   "WriteRegStr HKCU \\\"Environment\\\" \\\"OSL_HOME\\\" \\\"$INSTDIR\\\"")
  set (CPACK_NSIS_EXTRA_UNINSTALL_COMMANDS "DeleteRegValue HKCU \\\"Environment\\\" \\\"OSL_HOME\\\"")
elseif (APPLE)
  set(CMAKE_INSTALL_PREFIX "/Applications")
  set(CPACK_GENERATOR "DragNDrop")
  set(CPACK_DMG_FORMAT "UDBZ")
  set(CPACK_DMG_VOLUME_NAME "${PROJECT_NAME}")
  set(CPACK_SYSTEM_NAME "OSX")
  set(CPACK_PACKAGE_FILE_NAME "${PROJECT_NAME}-${PROJECT_VERSION}")
  #set(CPACK_PACKAGE_ICON "${ICONS_DIR}/DMG.icns")
  #set(CPACK_DMG_DS_STORE "${ICONS_DIR}/DMGDSStore")
  #set(CPACK_DMG_BACKGROUND_IMAGE "${ICONS_DIR}/DMGBackground.png")
elseif(UNIX)
  set(CPACK_SYSTEM_NAME "${CMAKE_SYSTEM_NAME}-${CMAKE_SYSTEM_PROCESSOR}")
endif()

## Binary
install (TARGETS gpsshogi gpsusi DESTINATION ${BIN_INSTALL_DIR})
## Data files
file (GLOB datafiles "${CMAKE_CURRENT_SOURCE_DIR}/../data/*.dat"
                     "${CMAKE_CURRENT_SOURCE_DIR}/../data/*.bin"
                     "${CMAKE_CURRENT_SOURCE_DIR}/../data/*.txt"
                     "${CMAKE_CURRENT_SOURCE_DIR}/../data/*.pair")
file (GLOB dataratingfiles "${CMAKE_CURRENT_SOURCE_DIR}/../data/rating/*.txt")
install (FILES ${datafiles}       DESTINATION "${DATA_INSTALL_DIR}")
install (FILES ${dataratingfiles} DESTINATION "${DATA_INSTALL_DIR}/rating")
## README
file (GLOB readmefiles "${CMAKE_CURRENT_SOURCE_DIR}/../sample/binary-dist/gpsshogi_setup/README*.txt")
install (FILES ${readmefiles} DESTINATION "./")
## licenses for data
install (FILES "${CMAKE_CURRENT_SOURCE_DIR}/../AUTHORS"
               "${CMAKE_CURRENT_SOURCE_DIR}/../COPYING"
               "${CMAKE_CURRENT_SOURCE_DIR}/../LICENSE"
         DESTINATION "${DATA_INSTALL_DIR}")
install (FILES "${CMAKE_CURRENT_SOURCE_DIR}/../sample/binary-dist/GPL-2"
         DESTINATION "${DATA_INSTALL_DIR}")
## licenses for binaries
### OSL
set (OSL_SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/../../osl")
install (FILES "${OSL_SOURCE_DIR}/AUTHORS" DESTINATION "${DOC_INSTALL_DIR}" RENAME "AUTHORS.osl")
install (FILES "${OSL_SOURCE_DIR}/LICENSE" DESTINATION "${DOC_INSTALL_DIR}" RENAME "LICENSE.osl")
### GPS
install (FILES "${CMAKE_CURRENT_SOURCE_DIR}/../AUTHORS" DESTINATION "${DOC_INSTALL_DIR}" RENAME "AUTHORS")
install (FILES "${CMAKE_CURRENT_SOURCE_DIR}/../COPYING" DESTINATION "${DOC_INSTALL_DIR}" RENAME "COPYING")
install (FILES "${CMAKE_CURRENT_SOURCE_DIR}/../LICENSE" DESTINATION "${DOC_INSTALL_DIR}" RENAME "LICENSE")
### GPL
install (FILES "${CMAKE_CURRENT_SOURCE_DIR}/../sample/binary-dist/GPL-2" DESTINATION "${DOC_INSTALL_DIR}")
if (MINGW)
  ### Boost
  install (FILES "${BOOST_ROOT}/LICENSE_1_0.txt" DESTINATION "${DOC_INSTALL_DIR}" RENAME "copyright.boost") 
  ### bzip2
  install (FILES "$ENV{HOME}/local/src/bzip2-1.0.6/LICENSE" DESTINATION "${DOC_INSTALL_DIR}" RENAME "copyright.bzip2") 
  ### Mingw
  install (FILES "/usr/share/doc/mingw-w64/copyright" DESTINATION "${DOC_INSTALL_DIR}" RENAME "copyright.mingw")
endif()

if(APPLE)
  set(CMAKE_INSTALL_SYSTEM_RUNTIME_DESTINATION "${BIN_INSTALL_DIR}")
  include(InstallRequiredSystemLibraries)

  set(EXECUTABLE "${PROJECT_NAME}.app")
elseif(WIN32)
  set(EXECUTABLE "${PROJECT_NAME}${CMAKE_EXECUTABLE_SUFFIX}")
else()
  set(EXECUTABLE "${BIN_INSTALL_DIR}/${PROJECT_NAME}${CMAKE_EXECUTABLE_SUFFIX}")
endif()

include (CPack)

=== bin/Makefile ===
GPSSHOGI_HOME = ..

-include makefile.local
include $(GPSSHOGI_HOME)/makefile.conf

#
all:
	$(MAKE) -C $(GPSSHOGI_HOME) 
	$(MAKE) programs
programs: gpsshogi gpsusi alphabetastat 

PROGRAM_SRCS = gpsshogi.cc gpsusi.cc alphabetastat.cc brinkmate.cc
SRCS = $(PROGRAM_SRCS) 
OBJS = $(patsubst %.cc,%.o,$(SRCS))

CC = $(CXX)
PROGRAMS = $(PROGRAM_SRCS:.cc=)

gpsusi gpsshogi alphabetastat brinkmate: $(FILE_OSL_ALL)

clean:
	-rm *.o $(PROGRAMS)
	-rm -rf .deps

light-clean:
	-rm -rf .deps .objs .gch 

-include $(patsubst %.cc,.deps/%.cc.d,$(SRCS))

.PHONY: all clean light-clean run-profile run-profile-mp run-profile-usi update-gpsusione

# gpsone: gpsone.cc gpsone.gcda gpsshogi.cc gpsoneprof
# 	$(CXX) -o $@ $(CXXFLAGS) $(OSL_HOME_FLAGS) $(PROFILE_USE) $(LDFLAGS) $< $(LDLIBS) $(FILE_TCMALLOC) $(LOADLIBES) -lbz2
# gpsoneprof: gpsone.cc gpsshogi.cc
# 	$(CXX) -o $@ $(CXXFLAGS) $(OSL_HOME_FLAGS) $(PROFILE_GENERATE) $(LDFLAGS) $< $(LDLIBS) $(FILE_TCMALLOC) $(LOADLIBES)
# gpsone-static: gpsone.cc gpsshogi.cc
# 	$(CXX) -o $@ $(CXXFLAGS) $(OSL_HOME_FLAGS) $(LDFLAGS) $< $(LDLIBS) $(FILE_TCMALLOC)  $(LOADLIBES) -lbz2
# 
# gpsusione: gpsusione.cc gpsusione.gcda gpsusi.cc gpsusioneprof
# 	$(CXX) -o $@ $(CXXFLAGS) $(OSL_HOME_FLAGS) $(PROFILE_USE) $(LDFLAGS) $< $(LDLIBS) $(FILE_TCMALLOC) $(LOADLIBES) -lbz2
# gpsusioneprof: gpsusione.cc gpsusi.cc
# 	$(CXX) -o $@ $(CXXFLAGS) $(OSL_HOME_FLAGS) $(PROFILE_GENERATE) $(LDFLAGS) $< $(LDLIBS) $(FILE_TCMALLOC) $(LOADLIBES)
# gpsusione-static: gpsusione.cc gpsusi.cc
# 	$(CXX) -o $@ $(CXXFLAGS) $(OSL_HOME_FLAGS) $(LDFLAGS) $< $(LDLIBS) $(FILE_TCMALLOC)  $(LOADLIBES) -lbz2
# 
# run-profile: gpsoneprof
# 	./gpsoneprof -e test --benchmark-more=16 -B45	
# run-profile-mp: gpsoneprof
# 	./gpsoneprof -e test --benchmark-more=16 -B45 -N1
# update-gpsone:
# 	-rm gpsoneprof gpsone gpsone.gcda 
# 	$(MAKE) gpsoneprof RELEASE=t
# 	$(MAKE) run-profile
# 	$(MAKE) gpsone RELEASE=t
# update-gpsone-mp:
# 	-rm gpsoneprof gpsone gpsone.gcda 
# 	$(MAKE) gpsoneprof RELEASE=t
# 	$(MAKE) run-profile-mp
# 	$(MAKE) gpsone RELEASE=t
# 
# run-profile-usi: gpsusioneprof
# 	./gpsusioneprof --profile --benchmark-more=16 --benchmark-seconds=45
# update-gpsusione:
# 	-rm gpsusioneprof gpsusione gpsusione.gcda 
# 	$(MAKE) gpsusioneprof RELEASE=t
# 	$(MAKE) run-profile-usi
# 	$(MAKE) gpsusione RELEASE=t

=== lib/Makefile ===
GPSSHOGI_HOME = ..
include $(GPSSHOGI_HOME)/makefile.conf
-include $(GPSSHOGI_HOME)/makefile.local
-include makefile.local

CXXOPTFLAGS ?= -O
OTHERFLAGS = -pipe -Wall -g $(CPUOPTION)

CXXFLAGS = -DOSL_HOME=\"`pwd`/..\" $(CXXOPTFLAGS) $(OTHERFLAGS) $(PROF) $(INCLUDES)
all : phony-mkdir libgpsshogi.a

PPAIR_OBJS = 
PROGRESS_OBJS = 
STAT_OBJS = 
EXPERIMENTAL_OBJS = 

OBJS = 	$(patsubst %.o,stat/%.o,$(STAT_OBJS)) \
	$(patsubst %.o,ppair/%.o,$(PPAIR_OBJS)) \
	$(patsubst %.o,progress/%.o,$(PROGRESS_OBJS))
SRCS = $(OBJS:.o=.cc)

-include $(patsubst %.cc,.deps/%.cc.d,$(SRCS))

phony-mkdir:
	-mkdir stat ppair > /dev/null 2>&1 
libgpsshogi.a : $(OBJS)
	$(ARC) $@ $(OBJS)
	-$(RANLIB) $@

clean: 
	-rm -f core *.o $(OBJS) $(PROGNAME) nohup.out
	-rm -rf .deps
distclean: clean 
	rm -f *~

=== release/Makefile ===
RELEASE = true
vpath %.cc ../bin

include ../bin/Makefile

=== test/Makefile ===
GPSSHOGI_HOME = ..
-include makefile.local
-include $(GPSSHOGI_HOME)/makefile.conf

INCLUDES += -I$(OSL_HOME)/test
CXXFLAGS =  -DOSL_HOME=\"$(shell dirname `pwd`)\" $(PROF) $(GCH_INCLUDES) $(INCLUDES)
LOADLIBES += -lgpsshogi -losl_search -losl_board -lcppunit -lboost_thread$(BOOST_POSTFIX) $(LDLIBS)

Q_PPAIR_OBJS = $(patsubst %.o,ppair/%.o,$(PPAIR_OBJS))
PPAIR_OBJS = pairDifferenceTest.o

Q_STAT_OBJS = $(patsubst %.o,stat/%.o,$(STAT_OBJS))
STAT_OBJS = iterativeLinearSolver.t.o valarrayMatrix.t.o sparseRegressionMultiplier.t.o

OBJS = testAll.o $(Q_PPAIR_OBJS) $(Q_STAT_OBJS)
SRCS = $(patsubst %.o,%.cc,$(OBJS))

TEST_DEPENDS = testAll.o $(GPSSHOGI_HOME)/lib/libgpsshogi.a $(FILE_OSL_ALL)

CC = $(CXX)

all: testPPair testStat

testPPair: $(Q_PPAIR_OBJS) $(TEST_DEPENDS)
	$(CXX) $(LDFLAGS) -o $@ $(Q_PPAIR_OBJS) testAll.o $(LOADLIBES) 
testStat: $(Q_STAT_OBJS)   $(TEST_DEPENDS)
	$(CXX) $(LDFLAGS) -o $@ $(Q_STAT_OBJS) testAll.o $(LOADLIBES) 
%.t: %.t.o $(TEST_DEPENDS)
	$(CXX) $(CXXFLAGS) -o $@ testAll.o $< $(LDFLAGS) $(LOADLIBES) 

-include $(patsubst %.cc,.deps/%.cc.d,$(SRCS))

=== lib/recorddb/Makefile ===
GPSSHOGI_HOME = ../..
include $(GPSSHOGI_HOME)/makefile.conf
-include $(GPSSHOGI_HOME)/makefile.local
-include makefile.local

CXXOPTFLAGS ?= -O
OTHERFLAGS = -pipe -Wall -g $(CPUOPTION)
INCLUDES += -I$(OSL_HOME)/lib/third_party/$(PROTOBUF)/src

CXXFLAGS = -DOSL_HOME=\"`pwd`/../..\" $(CXXOPTFLAGS) $(OTHERFLAGS) $(PROF) $(INCLUDES)
all:
	$(MAKE) -C$(GPSSHOGI_HOME)/lib/dbm
	$(MAKE) -C$(GPSSHOGI_HOME)/include/gpsshogi/recorddb
	$(MAKE) libgpsshogirecorddb.a

OBJS = recordDb.o facade.o evalDb.o
SRCS = $(OBJS:.o=.cc)

-include $(patsubst %.cc,.deps/%.cc.d,$(SRCS))

libgpsshogirecorddb.a : $(OBJS)
	$(ARC) $@ $(OBJS)
	-$(RANLIB) $@

clean: 
	$(MAKE) -C$(GPSSHOGI_HOME)/lib/dbm clean
	$(MAKE) -C$(GPSSHOGI_HOME)/include/gpsshogi/recorddb clean
	-rm -f core *.o $(OBJS) $(PROGNAME) nohup.out
	-rm -rf .deps
distclean: clean 
	rm -f *~

=== old-sample/bigram/Makefile ===
GPSSHOGI_HOME = ../..
include $(GPSSHOGI_HOME)/makefile.conf
-include makefile.local

OTHERFLAGS = -pipe $(CPUOPTION)
ifdef DEBUG
CXXOPTFLAGS ?= -O0
OTHERFLAGS += -g -DDEBUG
else
CXXOPTFLAGS = $(RELEASE_CXX_OPTFLAGS)
WARNING_FLAGS += $(WARN_INLINE)
ifdef RELEASE
OTHERFLAGS +=  -DNDEBUG
endif
endif

CXXFLAGS = $(PROF) $(OTHERFLAGS) $(CXXOPTFLAGS) $(WARNING_FLAGS) $(INCLUDES)
LOADLIBES += -lboost_program_options$(BOOST_POSTFIX) -lboost_thread$(BOOST_POSTFIX)

SRCS = show.cc
PROGRAMS = $(SRCS:.cc=)

all: $(PROGRAMS)
$(PROGRAMS): $(FILE_OSL_ALL)

CC = $(CXX)

clean: 
	-rm -f core *.o $(PROGRAMS) nohup.out *~
	-rm -rf .deps
distclean: clean 
	rm -f *~

-include $(patsubst %.cc,.deps/%.cc.d,$(SRCS))

=== old-sample/legacy-checkmate/Makefile ===
all: 
	$(MAKE) -C bin
clean:
	$(MAKE) -C bin clean
	$(MAKE) -C lib clean

=== old-sample/opening/Makefile ===
GPSSHOGI_HOME = ../..
INCLUDES += -I/usr/include/qdbm
include $(GPSSHOGI_HOME)/makefile.conf
-include makefile.local

# type make RELEASE=yes to build optimized programs
# type make DEBUG=true to build programs for debugging

ifdef DEBUG
CXXOPTFLAGS = -O0
OTHERFLAGS = -pipe -Wall $(CXXOPTFLAGS) -g -DDEBUG
else
CXXOPTFLAGS = -O2 -frename-registers -funroll-loops 
OTHERFLAGS = -pipe -Wall $(RELEASE_CXX_OPTFLAGS)
ifdef RELEASE
OTHERFLAGS += -DNDEBUG
endif
endif
LDFLAGS +=  -L$(CXX_HOME)/lib -Wl,-rpath,$(CXX_HOME)/lib -lqdbm

CXXFLAGS = $(PROF) $(INCLUDES) $(OTHERFLAGS)

SRCS = convert.cc
PROGRAMS = $(SRCS:.cc=)

all: convert
convert: convert.o editor.o converter.o
$(PROGRAMS): $(OSL_LIB_DIR)/libosl_board.a

CC = $(CXX)

clean: 
	-rm -f core *.o $(PROGRAMS) nohup.out *~
	-rm -rf .deps
distclean: clean 
	rm -f *~

-include $(patsubst %.cc,.deps/%.cc.d,$(SRCS))

=== old-sample/ppair/Makefile ===
GPSSHOGI_HOME = ../..
include $(GPSSHOGI_HOME)/makefile.conf
-include makefile.local

LOADLIBES += -lboost_thread$(BOOST_POSTFIX)

ifdef DEBUG
CXXOPTFLAGS += -O
OTHERFLAGS += -pipe -Wall $(CXXOPTFLAGS) -g -DDEBUG
else
CXXOPTFLAGS += -O2 -frename-registers -funroll-loops 
OTHERFLAGS += -pipe -Wall $(CXXOPTFLAGS) $(CPUOPTION) -fomit-frame-pointer -finline-limit=2000
ifdef RELEASE
OTHERFLAGS += -DNDEBUG
endif
endif

CXXFLAGS += -ffast-math $(PROF) $(INCLUDES) $(OTHERFLAGS)

SRCS = count.cc showDifferences.cc learn.cc quantize.cc annotate.cc \
	findQuiescence.cc weightstat.cc weightanalyzer.cc \
	learn2.cc scatter.cc akukei.cc
PROGRAMS = $(SRCS:.cc=)
LIBS = $(GPSSHOGI_LIB_DIR)/libgpsshogi.a $(FILE_OSL_ALL)

all: $(PROGRAMS)
$(PROGRAMS): $(LIBS)

CC = $(CXX)

clean: 
	rm -rf .deps
	rm -f core *.o $(PROGRAMS) nohup.out *~
distclean: clean 
	rm -f *~

count200000-20.txt:
	time ./count -m 20 -N 200000 -o $@
# weights10000-20.txt:
# 	time ./learn -m 20 -N 10000 -a count200000-20.txt -o $@
# weights10000W-20.txt:
# 	time ./learn -W -m 20 -N 10000 -a count200000-20.txt -o $@
# weights80000W-20.txt:
# 	time ./learn -W -m 20 -N 80000 -a count200000-20.txt -o $@

# weights200000Iq-20.txt:
# 	time ./learn -q annotate.dat -I -m 20 -N 200000 -a count200000-20.txt -o $@
# weights200000IHq-20.txt:
# 	time ./learn -q annotate.dat -H -I -m 20 -N 200000 -a count200000-20.txt -o $@

count200000qH.txt:  # annotate.dat
	time ./count -H -q annotate.dat -N 200000 -o $@
count200000q.txt:
	time ./count -q annotate.dat -N 200000 -o $@
count100000q.txt:
	time ./count -q annotate.dat -N 100000 -o $@
weights200000IHq.txt:
	-mkdir weights200000IHq
	time ./learn -t "weights200000IHq/tmp-" -q annotate.dat -H -I -N 200000 -a count200000qH.txt -o $@
weights200000Hq.txt:
	time ./learn -q annotate.dat -H -N 200000 -a count200000qH.txt -o $@

capturew100000.txt:
	time ./learn2 -q annotate.dat -N 100000 -a count100000q.txt -o $@
capturew100000-t40.txt:
	time ./learn2 -q annotate.dat -t tmp_weights2_t40.txt -T 40 -N 100000 -a count100000q.txt -o $@
# I: Ǥ initByPieceValue
capturew200000I.txt:
	time ./learn2 -I -q annotate.dat -N 200000 -a count200000q.txt -o $@


weights%.dat: weights%.txt
	./quantize -w $< -o $@

count235000-50-150.txt:
	time ./count -m 20 -M 150 -o $@
weights235000I-50-150.txt:
	time ./learn -I -m 50 -M 150 -N 235000 -a count235000-50-150.txt -o $@
weights235000W-50-150.txt:
	time ./learn -W -m 50 -M 150 -N 235000 -a count235000-50-150.txt -o $@

annotate.dat:
	time ./annotate  -o $@
annotate-c.dat:
	time ./annotate -c -o $@

-include $(patsubst %.cc,.deps/%.cc.d,$(SRCS))

=== old-sample/recorddb/Makefile ===
# Programs in this directory requires Tokyo Cabinet to be installed.
GPSSHOGI_HOME = ../..
include $(GPSSHOGI_HOME)/makefile.conf
-include makefile.local

OTHERFLAGS = -pipe $(CPUOPTION)
ifdef DEBUG
CXXOPTFLAGS ?= -O0
OTHERFLAGS += -g -DDEBUG
else
CXXOPTFLAGS = $(RELEASE_CXX_OPTFLAGS)
WARNING_FLAGS += $(WARN_INLINE)
ifdef RELEASE
OTHERFLAGS +=  -DNDEBUG
endif
endif

CXXFLAGS = $(PROF) $(OTHERFLAGS) $(CXXOPTFLAGS) $(WARNING_FLAGS) $(INCLUDES)
LOADLIBES += -lboost_program_options$(BOOST_POSTFIX) -lboost_thread$(BOOST_POSTFIX) -ltbb -ltokyocabinet -lz -lrt -lpthread -lm -lc $(OSL_HOME)/lib/third_party/$(PROTOBUF)/src/.libs/libprotobuf.a
INCLUDES += -I$(OSL_HOME)/lib/third_party/$(PROTOBUF)/src

SRCS = add-record.cc query.cc filter.cc eval.cc
PROGRAMS = $(SRCS:.cc=)

all:
	$(MAKE) update-lib
	$(MAKE) $(PROGRAMS)
$(PROGRAMS): $(GPSSHOGI_HOME)/lib/recorddb/libgpsshogirecorddb.a $(GPSSHOGI_HOME)/lib/dbm/libgpsshogidbm.a $(FILE_OSL_ALL)

CC = $(CXX)

update-lib:
	cd ../../lib/dbm; $(MAKE) RELEASE=$(RELEASE)
clean: 
	-rm -f core *.o $(PROGRAMS) nohup.out *~ 
	-rm -rf .deps *.pb.cc *.pb.h
distclean: clean 
	rm -f *~

-include $(patsubst %.cc,.deps/%.cc.d,$(SRCS))

.PHONY: all update-lib clean distclean

=== old-sample/stat/Makefile ===
GPSSHOGI_HOME = ../..
-include makefile.local
include $(GPSSHOGI_HOME)/makefile.conf

#
all: linear_solver

LOADLIBES += -lboost_thread$(BOOST_POSTFIX) -lboost_program_options$(BOOST_POSTFIX) -lpthread

## #gcc
OTHERFLAGS = -pipe 
# ifdef DEBUG
# CXXOPTFLAGS = -O
# OTHERFLAGS += -g -DDEBUG 
# else
# CXXOPTFLAGS = $(RELEASE_CXX_OPTFLAGS)
# WARNING_FLAGS += $(WARN_INLINE)
# endif
ifdef RELEASE
OTHERFLAGS +=  -DNDEBUG
endif

OTHERFLAGS += -ffast-math

CXXFLAGS = $(CPUOPTION) $(OTHERFLAGS) $(CXXOPTFLAGS) $(WARNING_FLAGS) $(INCLUDES)

PROGRAM_SRCS = linear_solver.cc
SRCS = $(PROGRAM_SRCS) 
OBJS = $(patsubst %.cc,%.o,$(SRCS))

CC = $(CXX)
PROGRAMS = $(PROGRAM_SRCS:.cc=)

$(PROGRAMS): $(FILE_GPSSHOGI) $(FILE_OSL_ALL)

clean:
	-rm *.o $(PROGRAMS)
	-rm -rf .deps

light-clean:
	-rm -rf .deps .objs .gch 

-include $(patsubst %.cc,.deps/%.cc.d,$(SRCS))

=== debian/changelog ===
gpsshogi (0.7.0-3.3) unstable; urgency=medium

  * Non-maintainer upload
  * Build for any arch (Closes: #1110758)

  [ Gioele Barabucci ]
  * Move Debian packaging into debian/ and mark as overlay repo
    (Closes: #1094872)

 -- Bastian Germann <bage@debian.org>  Sun, 10 Aug 2025 23:41:07 +0200

gpsshogi (0.7.0-3.2) unstable; urgency=medium

  * Non-maintainer upload.
  * d/copyright: Convert to standardized format
  * d/copyright: Include EPL text (Closes: #1069119)

 -- Bastian Germann <bage@debian.org>  Tue, 16 Apr 2024 18:56:27 +0000

gpsshogi (0.7.0-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * No change source-only upload for testing migration.

 -- Boyuan Yang <byang@debian.org>  Tue, 27 Sep 2022 15:03:18 -0400

gpsshogi (0.7.0-3) unstable; urgency=medium

  * New maintainer (Closes: #964730).
  * Include a patch for latest svn changes, only impacting the "upstream"
    branch in salsa.
  * Switch away from CDBS, to full dh 12.
  * Remove extra -l flags for libs not directly used.
  * Fix build with current Qt5 versions.
  * Split gpsshogi-viewer into its own package (Closes: #874108).
  * Fix Vcs-* control fields for salsa.
  * Get rid or manual debian/control parsing (lintian).

 -- Yann Dirson <dirson@debian.org>  Sat, 19 Dec 2020 16:37:44 +0100

gpsshogi (0.7.0-2) unstable; urgency=medium

  * Fix compile errors on i386:
    - debian/patches/0005-Fix-compile-errors-on-i386.patch
    (Closes: #861644)

 -- Daigo Moriwaki <daigo@debian.org>  Mon, 17 Jul 2017 07:27:47 +0000

gpsshogi (0.7.0-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Import back again un-incorporated NMU  0.6.0-3+nmu2.  Closes: 848345
  * Use HTTPS in Vcs-* headers.
  * Apply change in git reposiotry from Daigo Moriwaki: specify QT_SELECT=qt5
    and add a patch to build with qt5.

 -- Mattia Rizzolo <mattia@debian.org>  Fri, 31 Mar 2017 00:57:08 +0200

gpsshogi (0.7.0-1) unstable; urgency=medium

  * New upstream release (r3043).
  * Remove patches that are no longer applicable:
    - debian/patches/20100206-qt-common.pro.patch
    - debian/patches/20100528-makefile_conf_remove_malloc.patch
  * Add new patches:
    - debian/patches/0001-Customize-qmake-files.patch
    - debian/patches/0002-Customize-make-files.patch
    - debian/patches/0003-Fix-compiler-warnings-with-GCC-6.patch
    (Closes: #811689)

 -- Daigo Moriwaki <daigo@debian.org>  Sun, 04 Dec 2016 10:15:52 +0900

gpsshogi (0.6.0-3+nmu2) unstable; urgency=medium

  * Non-maintainer upload.

  [ Steve Langasek ]
  * Remove hard-coded dependency on libosl1. (Closes: #795237)

  [ Bas Couwenberg ]
  * Update build dependencies for GSL 2, change libgsl0-dev to libgsl-dev.
    (Closes: #807204)

 -- Sebastian Ramacher <sramacher@debian.org>  Sat, 02 Jan 2016 17:16:11 +0100

gpsshogi (0.6.0-3+nmu1) unstable; urgency=medium

  * Non-maintainer upload.
  * Change boost build-dep to be version-less (Closes: #759390).
  * Add hint "Shogi" to menu file.

 -- Yann Dirson <dirson@debian.org>  Thu, 09 Oct 2014 22:23:13 +0200

=== debian/control ===
Source: gpsshogi
Section: games
Priority: optional
Maintainer: Yann Dirson <dirson@debian.org>
Build-Depends: debhelper-compat (= 12), dpkg-dev (>= 1.16.1~), libosl-dev (>= 0.8.0), libboost-all-dev, libgoogle-perftools-dev, chrpath, help2man, qtbase5-dev, qtchooser, qt5-qmake, qtbase5-dev-tools, libpoco-dev, libreadline6-dev, libgsl-dev
Standards-Version: 3.9.8
Homepage: http://gps.tanaka.ecc.u-tokyo.ac.jp/gpsshogi/pukiwiki.php
Vcs-Git: https://salsa.debian.org/debian/gpsshogi.git
Vcs-Browser: https://salsa.debian.org/debian/gpsshogi

Package: gpsshogi
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, gpsshogi-data (= ${source:Version})
Suggests: gpsshogi-viewer
Description: Shogi playing program based on OpenShogiLib
 GPSShogi is a Shogi playing program based on OpenShogiLib and won the 19th
 World Computer Shogi Championship. This package contains several binaries to
 play with computer Shogi.
  - gpsshogi: support the CSA protocol
  - gpsusi: support the USI protocol
  - gpsshell: shell-like client to investigate positions

Package: gpsshogi-viewer
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, gpsshogi-data (= ${source:Version})
Description: Shogi studying GUI based on OpenShogiLib
 GPSShogi is a Shogi playing program based on OpenShogiLib and won the 19th
 World Computer Shogi Championship. This package contains the gpsshogi-viewer
 GUI application to investigate positions.

Package: gpsshogi-data
Architecture: all
Recommends: gpsshogi
Depends: ${misc:Depends}
Description: data files for gpsshogi
 GPSShogi is a Shogi playing program based on OpenShogiLib and won the 19th
 World Computer Shogi Championship. This package contains several binaries to
 play with computer Shogi.
  - gpsshogi: support the CSA protocol
  - gpsusi: support the USI protocol
  - gpsshogi-viewer: GUI application to investigate positions
  - gpsshell: shell-like client to investigate positions
 .
 This package contains data files defining parameters of evaluation functions,
 an opening book for gpsshogi

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

DPKG_EXPORT_BUILDFLAGS = 1

include /usr/share/dpkg/buildflags.mk
CFLAGS += $(CPPFLAGS)
CXXFLAGS += $(CPPFLAGS)
LDFLAGS += -Wl,--as-needed

DEB_DBG_PACKAGE_gpsshogi = gpsshogi-dbg
DEB_INSTALL_DIRS_gpsshogi += usr/games
DEB_INSTALL_MANPAGES_gpsshogi += debian/gpsusi.1
DEB_INSTALL_MANPAGES_gpsshogi += debian/gpsshogi.1
DEB_INSTALL_MANPAGES_gpsshogi += debian/gpsshell.1
DEB_INSTALL_MANPAGES_gpsshogi += debian/gpsshogi-viewer.1
DEB_INSTALL_DOCS_gpsshogi += debian/epl-v10.txt
DEB_INSTALL_DIRS_gpsshogi_data += usr/share/gpsshogi-data/data

export OSL_HOME = /usr/share/libosl-dev
#OSL_HOME_FLAGS = -DOSL_HOME=\\\"/usr/share/gpsshogi-data\\\"
export FILE_TCMALLOC = ''

export QT_SELECT = qt5
export OSL_HOME_QT = ''
export TCMALLOC = ''

%:
	dh $@

override_dh_auto_configure:
	true # nothing for all those Makefiles
	# viewer
	dh_auto_configure --buildsystem=qmake --sourcedirectory=lib/gui
	dh_auto_configure --buildsystem=qmake --sourcedirectory=sample/viewer

override_dh_auto_build:
	# gpsusi, gpsshogi
	dh_auto_build --buildsystem=makefile --sourcedirectory=bin -- gpsshogi gpsusi \
		FILE_OSL_ALL='' LDLIBS='-losl -lboost_filesystem -lboost_system -ltcmalloc_minimal' RELEASE=t
	help2man --section 6 -n "GPSShogi for XShogi and the CSA protocol" --no-info \
	  $(CURDIR)/bin/gpsshogi > $(CURDIR)/debian/gpsshogi.1
	help2man --section 6 -n "GPSShogi for the USI protocol" --no-info \
	  $(CURDIR)/bin/gpsusi > $(CURDIR)/debian/gpsusi.1
	# gpsshell
	dh_auto_build --buildsystem=makefile --sourcedirectory=sample/gpsshell -- gpsshell \
		FILE_OSL_ALL='' LDLIBS='-losl -lboost_filesystem -lboost_system -ltcmalloc_minimal' RELEASE=t
	help2man --section 6 -n "GPSShogi shell like client" --version-string "gpsshell" --no-info \
	  $(CURDIR)/sample/gpsshell/gpsshell > $(CURDIR)/debian/gpsshell.1
	# viewer
	dh_auto_build --buildsystem=qmake --sourcedirectory=lib/gui
	dh_auto_build --buildsystem=qmake --sourcedirectory=sample/viewer
	$(MAKE) viewer-release
	mv sample/viewer/viewer sample/viewer/gpsshogi-viewer

	chrpath --delete bin/gpsusi bin/gpsshogi sample/gpsshell/gpsshell sample/viewer/gpsshogi-viewer

clean::
	for dir in lib/gui sample/viewer ; do \
	  [ ! -f $$dir/Makefile ] || $(MAKE) -C $$dir OSL_HOME=/usr/share/libosl-dev distclean ; \
	done
	for dir in lib bin sample/gpsshell ; do \
	  $(MAKE) -C $$dir OSL_HOME=/usr/share/libosl-dev clean ; \
	done
	-rm -f $(CURDIR)/sample/viewer/gpsshogi-viewer
	for file in gpsusi gpsshogi gpsshell ; do \
	  rm -rf $(CURDIR)/debian/$$file.1 ; \
	done

include /usr/share/dpkg/pkg-info.mk
SRCDIR_NAME = $(DEB_SOURCE)-$(DEB_VERSION_UPSTREAM).orig

get-orig-source:
	if [ ! -f gpsshogi.tar.gz ] ; then \
	  wget -O gpsshogi.tar.gz "http://gps.tanaka.ecc.u-tokyo.ac.jp/cgi-bin/viewvc.cgi/trunk/gpsshogi.tar.gz?root=gpsshogi&view=tar" ; \
        fi
	mkdir debian/$(SRCDIR_NAME)
	cd debian/$(SRCDIR_NAME) && tar xzvf ../../gpsshogi.tar.gz
	if test "`ls debian/$(SRCDIR_NAME) | wc -l`" -eq "1" ; then \
	        subdir=`echo debian/$(SRCDIR_NAME)/*` && \
		find $$subdir -mindepth 1 -maxdepth 1 -exec mv -t debian/$(SRCDIR_NAME) -- {} + && \
	        rmdir $$subdir ; \
	fi
	tar czf ../$(DEB_SOURCE)_$(DEB_VERSION_UPSTREAM).orig.tar.gz -C debian $(SRCDIR_NAME)
	rm -rf debian/$(SRCDIR_NAME)
